Overview | Package | Class | Tree | Deprecated | Index | Help
| JSS 3.1.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.mozilla.jss.pkcs11
Class PK11SymKey

    java.lang.Object
      |
      +--org.mozilla.jss.pkcs11.PK11SymKey

All Implemented Interfaces:
  SymmetricKey

public final class PK11SymKey
extends java.lang.Object
implements SymmetricKey

Inner classes inherited from class org.mozilla.jss.crypto.SymmetricKey
`SymmetricKey.NotExtractableException, SymmetricKey.Type, SymmetricKey.Usage`

Field Summary
`private SymKeyProxy` | `keyProxy`

Fields inherited from interface org.mozilla.jss.crypto.SymmetricKey
`DES, DES3, RC2, RC4, SHA1_HMAC`

Constructor Summary
`protected` | `PK11SymKey(byte[] pointer)`

Method Summary
`byte[]` | `getKeyData()`
`KeyType` | `getKeyType()`
`CryptoToken` | `getOwningToken()`
`int` | `getStrength()` Returns key strength, measured as the number of bits of secret material.
`SymmetricKey.Type` | `getType()`

Methods inherited from class java.lang.Object
`, clone, equals, finalize, getClass, hashCode, notify, notifyAll, registerNatives, toString, wait, wait, wait`

Field Detail

### keyProxy

    private SymKeyProxy keyProxy

Constructor Detail

### PK11SymKey

    protected PK11SymKey(byte[] pointer)

Method Detail

### getType

    public SymmetricKey.Type getType()

  Specified by:
    `getType` in interface `SymmetricKey`

### getOwningToken

    public CryptoToken getOwningToken()

  Specified by:
    `getOwningToken` in interface `SymmetricKey`

### getStrength

    public int getStrength()

  Returns key strength, measured as the number of bits of secret material. NOTE: Due to a bug in the security library (333440), this may return a wrong answer for PBE keys that have embedded parity (like DES). A DES key is 56 bits of information plus 8 bits of parity, so it takes up 64 bits. For a normal DES key, this method will correctly return 56, but for a PBE-generated DES key, the security library bug causes it to return 64.
  Specified by:
    `getStrength` in interface `SymmetricKey`

### getKeyData

    public byte[] getKeyData()
                      throws SymmetricKey.NotExtractableException

  Specified by:
    `getKeyData` in interface `SymmetricKey`

### getKeyType

    public KeyType getKeyType()

Overview | Package | Class | Tree | Deprecated | Index | Help
| JSS 3.1.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD